package com.tzld.piaoquan.recommend.server.service.rank.processor;

import com.tzld.piaoquan.recommend.server.model.Video;
import org.apache.commons.collections4.CollectionUtils;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 提权处理器
 *
 * @author sunxy
 */
public class RankProcessorBoost {

    public static void boostByTag(List<Video> rovList, Map<String, Map<String, String>> rulesMap) {
        if (CollectionUtils.isEmpty(rovList) || rulesMap == null || rulesMap.isEmpty()) {
            return;
        }
        Map<String, Double> densityRules = new HashMap<>();
        for (Map.Entry<String, Map<String, String>> entry : rulesMap.entrySet()) {
            String key = entry.getKey();
            Map<String, String> value = entry.getValue();
            if (value.containsKey("boost")) {
                densityRules.put(key, Double.valueOf(value.get("boost")));
            }
        }


        for (Map.Entry<String, Double> entry : densityRules.entrySet()) {
            rovList.stream().filter(video -> video.getTags().contains(entry.getKey()))
                    .forEach(video -> video.setSortScore(
                            BigDecimal.valueOf(video.getSortScore())
                                    .multiply(BigDecimal.valueOf(entry.getValue()))
                                    .doubleValue()));
        }
        rovList.sort((o1, o2) -> Double.compare(o2.getSortScore(), o1.getSortScore()));

    }


}
